'use strict';

var fs = require('fs');
var Table = require('cli-table');

function isCorrectPathFile(path) {
  return true;
}

class Booker {
  constructor() {
    var database = JSON.parse(fs.readFileSync('../database.json'));
    this.list = database.list;
    this.wishList = database.wishList;
  }
  saveDB() {
    var databaseObject = {
      list: this.list,
      wishlist: this.wishList
    };
    fs.writeFile('../database.json', JSON.stringify(databaseObject), 'utf-8');
  }
  printList() {
    var table = new Table({
      head: ['ID', 'Title', 'Author', 'Category', 'Pages read', 'Pages All', '% read']
    });
    for (var i=0;i<this.list.length;i++) {
      var currentRow = [];
      currentRow.push(this.list[i].id)
      currentRow.push(this.list[i].title)
      currentRow.push(this.list[i].author)
      currentRow.push(this.list[i].category)
      currentRow.push(this.list[i].done)
      currentRow.push(this.list[i].pages)
      currentRow.push(parseInt(this.list[i].done / this.list[i].pages) * 100 + "%")
      console.log(currentRow)
      table.push(currentRow);
    }
    console.log(table.toString());
  }
  addToListLocally(options) {
    if (!options.author) {
      throw "Error: author is required";
    }
    if (!options.title) {
      throw "Error: title is required"
    }
    if (!options.path) {
      throw "Error: path is required"
    }
    if (!isCorrectPathFile(options.path)) {
      throw "Error: incorrect path to book file. Please, check directory and type of file"
    }
    this.list.push({
      id: Date.now(),
      title: options.title,
      author: options.author,
      category: options.category,
      pages: options.pages,
      done: options.done,
      tags: options.tags,
      path: options.path
    })
    this.saveDB()
  }
}
module.exports = Booker;